2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
5 ## Copyright (C) 2001-2024 Free Software Foundation, Inc.
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <https://www.gnu.org/licenses/>.
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
24 # These variables ought to be defined through the configure.ac section
25 # of the module description. But some packages import this file directly,
26 # ignoring the module description.
33 _sp
= $(_empty
) $(_empty
)
37 # If S1 == S2, return S1, otherwise the empty string.
38 _equal
= $(and
$(findstring $(1),$(2)),$(findstring $(2),$(1)))
40 # member-check,VARIABLE,VALID-VALUES
41 # ----------------------------------
42 # Check that $(VARIABLE) is in the space-separated list of VALID-VALUES, and
43 # return it. Die otherwise.
47 $(if
$(findstring $(_sp
),$($(1))), \
48 $(error invalid
$(1): '$($(1))', expected
$(2)), \
49 $(or
$(findstring $(_sp
)$($(1))$(_sp
),$(_sp
)$(2)$(_sp
)), \
50 $(error invalid
$(1): '$($(1))', expected
$(2)))), \
51 $(error
$(1) undefined
)))
53 # Do not save the original name or timestamp in the .tar.gz file.
54 # Use --rsyncable if available.
56 $(shell gzip
--help
2>/dev
/null|
$(GREP
) rsyncable
>/dev
/null \
57 && printf
%s
--rsyncable
)
58 GZIP_ENV
= '--no-name --best $(gzip_rsyncable)'
63 VC_LIST
= $(srcdir)/$(_build-aux
)/vc-list-files
-C
$(srcdir)
65 # You can override this variable in cfg.mk if your gnulib submodule lives
66 # in a different location.
67 gnulib_dir ?
= $(shell if
test -n
"$(GNULIB_SRCDIR)" && test -f
"$(GNULIB_SRCDIR)/gnulib-tool"; then \
68 echo
"$(GNULIB_SRCDIR)"; \
70 echo
$(srcdir)/gnulib
; \
73 # You can override this variable in cfg.mk to set your own regexp
74 # matching files to ignore.
75 VC_LIST_ALWAYS_EXCLUDE_REGEX ?
= ^
$$
77 # This is to preprocess robustly the output of $(VC_LIST), so that even
78 # when $(srcdir) is a pathological name like "....", the leading sed command
79 # removes only the intended prefix.
80 _dot_escaped_srcdir
= $(subst .
,\.
,$(srcdir))
82 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
83 # when $(srcdir) is not ".".
85 _prepend_srcdir_prefix
=
87 _prepend_srcdir_prefix
= |
$(SED
) 's|^|$(srcdir)/|'
90 # In order to be able to consistently filter "."-relative names,
91 # (i.e., with no $(srcdir) prefix), this definition is careful to
92 # remove any $(srcdir) prefix, and to restore what it removes.
94 $(or
$(exclude_file_name_regexp--
$@
),^
$$)
96 $(VC_LIST
) |
$(SED
) 's|^$(_dot_escaped_srcdir)/||' \
97 | if
test -f
$(srcdir)/.x-
$@
; then
$(GREP
) -vEf
$(srcdir)/.x-
$@
; \
98 else $(GREP
) -Ev
-e
"$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
99 |
$(GREP
) -Ev
-e
'($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
100 $(_prepend_srcdir_prefix
)
102 ifeq ($(origin prev_version_file
), undefined
)
103 prev_version_file
= $(srcdir)/.prev-version
106 PREV_VERSION
:= $(shell cat
$(prev_version_file
) 2>/dev
/null
)
107 VERSION_REGEXP
= $(subst .
,\.
,$(VERSION
))
108 PREV_VERSION_REGEXP
= $(subst .
,\.
,$(PREV_VERSION
))
111 this-vc-tag
= v
$(VERSION
)
112 this-vc-tag-regexp
= v
$(VERSION_REGEXP
)
114 tag-package
= $(shell echo
"$(PACKAGE)" | tr
'[:lower:]' '[:upper:]')
115 tag-this-version
= $(subst .
,_
,$(VERSION
))
116 this-vc-tag
= $(tag-package
)-$(tag-this-version
)
117 this-vc-tag-regexp
= $(this-vc-tag
)
119 my_distdir
= $(PACKAGE
)-$(VERSION
)
121 # Old releases are stored here.
122 release_archive_dir ?
= ..
/release
124 # If RELEASE_TYPE is undefined, but RELEASE is, use its second word.
125 # But overwrite VERSION.
127 VERSION
:= $(word 1, $(RELEASE
))
128 RELEASE_TYPE ?
= $(word 2, $(RELEASE
))
131 # Validate and return $(RELEASE_TYPE), or die.
132 RELEASE_TYPES
= alpha beta stable
133 release-type
= $(call member-check
,RELEASE_TYPE
,$(RELEASE_TYPES
))
135 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
136 # Use alpha.gnu.org for alpha and beta releases.
137 # Use ftp.gnu.org for stable releases.
138 gnu_ftp_host-alpha
= alpha.gnu.org
139 gnu_ftp_host-beta
= alpha.gnu.org
140 gnu_ftp_host-stable
= ftp.gnu.org
141 gnu_rel_host ?
= $(gnu_ftp_host-
$(release-type
))
143 url_dir_list ?
= $(if
$(call _equal
,$(gnu_rel_host
),ftp.gnu.org
), \
144 https
://ftpmirror.gnu.org
/$(PACKAGE
), \
145 https
://$(gnu_rel_host
)/gnu
/$(PACKAGE
))
147 # Override this in cfg.mk if you are using a different format in your
149 today
= $(shell date
+%Y-
%m-
%d
)
151 # Select which lines of NEWS are searched for $(news-check-regexp).
152 # This is a sed line number spec. The default says that we search
153 # lines 1..10 of NEWS for $(news-check-regexp).
154 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
155 news-check-lines-spec ?
= 1,10
156 news-check-regexp ?
= '^\*.* $(VERSION_REGEXP) \($(today)\)'
158 # Prevent programs like 'sort' from considering distinct strings to be equal.
159 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
162 ## --------------- ##
164 ## --------------- ##
166 ifneq ($(_gl-Makefile
),)
167 _cfg_mk
:= $(wildcard $(srcdir)/cfg.mk
)
169 # Collect the names of rules starting with 'sc_'.
170 syntax-check-rules
:= $(sort $(shell env LC_ALL
=C
$(SED
) -n \
171 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(srcdir)/$(ME
) $(_cfg_mk
)))
172 .PHONY
: $(syntax-check-rules
)
174 ifeq ($(shell $(VC_LIST
) >/dev
/null
2>&1; echo
$$?
),0)
175 local-checks-available
+= $(syntax-check-rules
)
177 local-checks-available
+= no-vc-detected
179 @echo
"No version control files detected; skipping syntax check"
181 .PHONY
: $(local-checks-available
)
183 # Arrange to prine the name of each syntax-checking rule just before running it.
184 $(syntax-check-rules
): %: %.m
185 sc_m_rules_
= $(patsubst %, %.m
, $(syntax-check-rules
))
186 .PHONY
: $(sc_m_rules_
)
188 @echo
$(patsubst sc_
%.m
, %, $@
)
189 @date
+%s.
%N
> .sc-start-
$(basename $@
)
191 # Compute and print the elapsed time for each syntax-check rule.
192 sc_z_rules_
= $(patsubst %, %.z
, $(syntax-check-rules
))
193 .PHONY
: $(sc_z_rules_
)
194 $(sc_z_rules_
): %.z
: %
195 @end
=$$(date
+%s.
%N
); \
196 start
=$$(cat .sc-start-
$*); \
197 rm -f .sc-start-
$*; \
198 $(AWK
) -v s
=$$start -v e
=$$end \
199 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev
/null
201 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
202 # that computes and prints elapsed time.
204 $(patsubst sc_
%, sc_
%.z
, \
205 $(filter-out $(local-checks-to-skip
), $(local-checks-available
)))
207 syntax-check
: $(local-check
)
212 # This macro searches for a given construct in the selected files and
213 # then takes some action.
215 # Parameters (shell variables):
219 # Regular expression (ERE) denoting either a forbidden construct
220 # or a required construct. Those arguments are exclusive.
224 # Regular expression (ERE) denoting lines to ignore that matched
225 # a prohibit construct. For example, this can be used to exclude
226 # comments that mention why the nearby code uses an alternative
227 # construct instead of the simpler prohibited construct.
229 # in_vc_files | in_files
231 # grep-E-style regexp selecting the files to check. For in_vc_files,
232 # the regexp is used to select matching files from the list of all
233 # version-controlled files; for in_files, it's from the names printed
234 # by "find $(srcdir)". When neither is specified, use all files that
235 # are under version control.
237 # containing | non_containing
239 # Select the files (non) containing strings matching this regexp.
240 # If both arguments are specified then CONTAINING takes
245 # Extra options for grep.
253 # Message to display before to halting execution.
255 # Finally, you may exempt files based on an ERE matching file names.
256 # For example, to exempt from the sc_space_tab check all files with the
257 # .diff suffix, set this Make variable:
259 # exclude_file_name_regexp--sc_space_tab = \.diff$
261 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
262 # when filtering by name via in_files, we explicitly filter out matching
263 # names here as well.
265 # Initialize each, so that envvar settings cannot interfere.
272 export non_containing
=
274 export with_grep_options
=
276 # By default, _sc_search_regexp does not ignore case.
278 _ignore_case
= $$(test -n
"$$ignore_case" && printf
%s
-i ||
:)
280 define _sc_say_and_exit
281 dummy
=; : so we do not need a semicolon before each use
; \
282 { printf
'%s\n' "$(ME): $$msg" 1>&2; exit
1; };
285 define _sc_search_regexp
286 dummy
=; : so we do not need a semicolon before each use
; \
289 test -n
"$$prohibit" && test -n
"$$require" \
290 && { msg
='Cannot specify both prohibit and require' \
291 $(_sc_say_and_exit
) } ||
:; \
292 test -z
"$$prohibit" && test -z
"$$require" \
293 && { msg
='Should specify either prohibit or require' \
294 $(_sc_say_and_exit
) } ||
:; \
295 test -z
"$$prohibit" && test -n
"$$exclude" \
296 && { msg
='Use of exclude requires a prohibit pattern' \
297 $(_sc_say_and_exit
) } ||
:; \
298 test -n
"$$in_vc_files" && test -n
"$$in_files" \
299 && { msg
='Cannot specify both in_vc_files and in_files' \
300 $(_sc_say_and_exit
) } ||
:; \
301 test "x$$halt" != x \
302 ||
{ msg
='halt not defined' $(_sc_say_and_exit
) }; \
304 : Filter by file name
; \
305 if
test -n
"$$in_files"; then \
306 files
=$$(find
$(srcdir) |
$(GREP
) -E
"$$in_files" \
307 |
$(GREP
) -Ev
'$(_sc_excl)'); \
309 files
=$$($(VC_LIST_EXCEPT
)); \
310 if
test -n
"$$in_vc_files"; then \
311 files
=$$(echo
"$$files" |
$(GREP
) -E
"$$in_vc_files"); \
315 : Filter by content
; \
317 && test -n
"$$containing" \
318 && { files
=$$(echo
"$$files" | xargs
$(GREP
) -l
"$$containing"); } \
321 && test -n
"$$non_containing" \
322 && { files
=$$(echo
"$$files" | xargs
$(GREP
) -vl
"$$non_containing"); } \
325 : Check for the construct
; \
326 if
test -n
"$$files"; then \
327 if
test -n
"$$prohibit"; then \
329 | xargs
$(GREP
) $$with_grep_options $(_ignore_case
) -nE \
330 "$$prohibit" /dev
/null \
331 |
$(GREP
) -vE
"$${exclude:-^$$}" \
332 && { msg
="$$halt" $(_sc_say_and_exit
) } \
337 $(GREP
) $$with_grep_options $(_ignore_case
) -LE
"$$require" \
339 && { msg
="$$halt" $(_sc_say_and_exit
) } \
346 sc_avoid_if_before_free
:
348 |
$(GREP
) -v useless-if-before-free \
350 $(srcdir)/$(_build-aux
)/useless-if-before-free \
351 $(useless_free_options
) \
352 && { printf
'$(ME): found useless "if"' \
353 ' before "free" above\n' 1>&2; \
357 sc_cast_of_argument_to_free
:
358 @prohibit
='\<free *\( *\(' halt
="don't cast free argument" \
361 sc_cast_of_x_alloc_return_value
:
362 @prohibit
='\*\) *x(m|c|re)alloc\>' \
363 halt
="don't cast x*alloc return value" \
366 sc_cast_of_alloca_return_value
:
367 @prohibit
='\*\) *alloca\>' \
368 halt
="don't cast alloca return value" \
373 halt
='found SPACE-TAB sequence; remove the SPACE' \
376 # Don't use *scanf or the old ato* functions in "real" code.
377 # They provide no error checking mechanism.
378 # Instead, use strto* functions.
379 sc_prohibit_atoi_atof
:
380 @prohibit
='\<([fs]?scanf|ato([filq]|ll)) *\(' \
381 halt
='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
384 # Use STREQ rather than comparing strcmp == 0, or != 0.
387 @prohibit
='! *strcmp *\(|\<$(sp_) *[!=]=|[!=]= *$(sp_)' \
388 exclude
='# *define STRN?EQ\(' \
389 halt
='replace strcmp calls above with STREQ/STRNEQ' \
392 # Really. You don't want to use this function.
393 # It may fail to NUL-terminate the destination,
394 # and always NUL-pads out to the specified length.
396 @prohibit
='\<strncpy *\(' \
397 halt
='do not use strncpy, period' \
400 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
401 # Convert all uses automatically, via these two commands:
402 # git grep -l '\<exit *(1)' \
403 # | grep -vEf .x-sc_prohibit_magic_number_exit \
404 # | xargs --no-run-if-empty \
405 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
406 # git grep -l '\<exit *(0)' \
407 # | grep -vEf .x-sc_prohibit_magic_number_exit \
408 # | xargs --no-run-if-empty \
409 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
410 sc_prohibit_magic_number_exit
:
411 @prohibit
='(^|[^.])\<(usage|exit|error) ?\(-?[0-9]+[,)]' \
412 exclude
='exit \(77\)|error ?\(((0|77),|[^,]*)' \
413 halt
='use EXIT_* values rather than magic number' \
416 # Check that we don't use $< in non-implicit Makefile rules.
418 # To find the Makefiles, trace AC_CONFIG_FILES. Using VC_LIST would
419 # miss the Makefiles that are not under VC control (e.g., symlinks
420 # installed for gettext). "Parsing" (recursive) uses of SUBDIRS seems
423 # Use GNU Make's --print-data-base to normalize the rules into some
424 # easy to parse format: they are separated by two \n. Look for the
425 # "section" about non-pattern rules (marked with "# Files") inside
426 # which there are still the POSIX Make like implicit rules (".c.o").
427 sc_prohibit_gnu_make_extensions_awk_
= \
435 /\
$$</ && in_rules
&& $$0 !~
/^
(.
*\n)*\.\w
+(\.\w
+)?
:/ { \
436 print "Error: " file
": $$< in a non implicit rule\n" $$0; \
442 sc_prohibit_gnu_make_extensions
:
443 @if
$(AWK
) --version | grep GNU
>/dev
/null
2>&1; then \
444 (cd
$(srcdir) && autoconf
--trace AC_CONFIG_FILES
:'$$1') | \
446 $(SED
) -ne
'/Makefile/{s/\.in$$//;p;}' | \
448 $(MAKE
) -qp
-f
$$m .DUMMY-TARGET
2>/dev
/null | \
449 $(AWK
) -v file
=$$m -e
'$($@_awk_)' || exit
1; \
453 # Using EXIT_SUCCESS as the first argument to error is misleading,
454 # since when that parameter is 0, error does not exit. Use '0' instead.
455 sc_error_exit_success
:
456 @prohibit
='error *\(EXIT_SUCCESS,' \
457 in_vc_files
='\.[chly]$$' \
458 halt
='found error (EXIT_SUCCESS' \
461 # "FATAL:" should be fully upper-cased in error messages
462 # "WARNING:" should be fully upper-cased, or fully lower-cased
463 sc_error_message_warn_fatal
:
465 | xargs
$(GREP
) -nEA2
'[^rp]error *\(' /dev
/null \
466 |
$(GREP
) -E
'"Warning|"Fatal|"fatal' \
467 && { echo
'$(ME): use FATAL, WARNING or warning' 1>&2; \
471 # Error messages should not start with a capital letter
472 sc_error_message_uppercase
:
474 | xargs
$(GREP
) -nEA2
'[^rp]error *\(' /dev
/null \
475 |
$(GREP
) -E
'"[A-Z]' \
476 |
$(GREP
) -vE
'"FATAL|"WARNING|"Java|"C#|"PRI' \
477 && { echo
'$(ME): found capitalized error message' 1>&2; \
481 # Error messages should not end with a period
482 sc_error_message_period
:
484 | xargs
$(GREP
) -nEA2
'[^rp]error *\(' /dev
/null \
485 |
$(GREP
) -E
'[^."]\."' \
486 && { echo
'$(ME): found error message ending in period' 1>&2; \
491 @prohibit
=file
''system \
492 exclude
='/proc/filesystems' \
494 halt
='found use of "file''system"; spell it "file system"' \
497 # Don't use cpp tests of this symbol. All code assumes config.h is included.
498 sc_prohibit_have_config_h
:
499 @prohibit
='^# *if.*HAVE''_CONFIG_H' \
500 halt
='found use of HAVE''_CONFIG_H; remove' \
503 # Nearly all .c files must include <config.h>. However, we also permit this
504 # via inclusion of a package-specific header, if cfg.mk specified one.
505 # config_h_header must be suitable for grep -E.
506 config_h_header ?
= <config\.h
>
508 @require
='^# *include $(config_h_header)' \
509 in_vc_files
='\.c$$' \
510 halt
='the above files do not include <config.h>' \
513 # Print each file name for which the first #include does not match
514 # $(config_h_header). Like grep -m 1, this only looks at the first match.
515 perl_config_h_first_
= \
516 -e
'BEGIN {$$ret = 0}' \
517 -e
'if (/^\# *include\b/) {' \
518 -e
' if (not m{^\# *include $(config_h_header)}) {' \
519 -e
' print "$$ARGV\n";' \
522 -e
' \# Move on to next file after first include' \
525 -e
'END {exit $$ret}'
527 # You must include <config.h> before including any other header file.
528 # This can possibly be via a package-specific header, if given by cfg.mk.
529 sc_require_config_h_first
:
530 @if
$(VC_LIST_EXCEPT
) |
$(GREP
) '\.c$$' > /dev
/null
; then \
531 files
=$$($(VC_LIST_EXCEPT
) |
$(GREP
) '\.c$$') && \
532 perl
-n
$(perl_config_h_first_
) $$files || \
533 { echo
'$(ME): the above files include some other header' \
534 'before <config.h>' 1>&2; exit
1; } ||
:; \
538 sc_prohibit_HAVE_MBRTOWC
:
539 @prohibit
='\bHAVE_MBRTOWC\b' \
540 halt
="do not use $$prohibit; it is always defined" \
543 # To use this "command" macro, you must first define two shell variables:
544 # h: the header name, with no enclosing <> or ""
545 # re: a regular expression that matches IFF something provided by $h is used.
546 define _sc_header_without_use
547 dummy
=; : so we do not need a semicolon before each use
; \
548 h_esc
=`echo '[<"]'"$$h"'[">]'|$(SED) 's/\./\\\\./g'`; \
549 if
$(VC_LIST_EXCEPT
) |
$(GREP
) '\.c$$' > /dev
/null
; then \
550 files
=$$($(GREP
) -l
'^# *include '"$$h_esc" \
551 $$($(VC_LIST_EXCEPT
) |
$(GREP
) '\.c$$')) && \
552 $(GREP
) -LE
"$$re" $$files |
$(GREP
) .
&& \
553 { echo
"$(ME): the above files include $$h but don't use it" \
554 1>&2; exit
1; } ||
:; \
559 # Prohibit the inclusion of assert.h without an actual use of assert.
560 sc_prohibit_assert_without_use
:
561 @h
='assert.h' re
='\<assert *\(' $(_sc_header_without_use
)
563 # Prohibit the inclusion of close-stream.h without an actual use.
564 sc_prohibit_close_stream_without_use
:
565 @h
='close-stream.h' re
='\<close_stream *\(' $(_sc_header_without_use
)
567 # Prohibit the inclusion of getopt.h without an actual use.
568 sc_prohibit_getopt_without_use
:
569 @h
='getopt.h' re
='\<getopt(_long)? *\(' $(_sc_header_without_use
)
571 # Don't include quotearg.h unless you use one of its functions.
572 sc_prohibit_quotearg_without_use
:
573 @h
='quotearg.h' re
='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use
)
575 # Don't include quote.h unless you use one of its functions.
576 sc_prohibit_quote_without_use
:
577 @h
='quote.h' re
='\<quote((_n)? *\(|_quoting_options\>)' \
578 $(_sc_header_without_use
)
580 # Don't include this header unless you use one of its functions.
581 sc_prohibit_long_options_without_use
:
582 @h
='long-options.h' re
='\<parse_(long_options|gnu_standard_options_only) *\(' \
583 $(_sc_header_without_use
)
585 # Don't include this header unless you use one of its functions.
586 sc_prohibit_inttostr_without_use
:
587 @h
='inttostr.h' re
='\<(off|[iu]max|uint)tostr *\(' \
588 $(_sc_header_without_use
)
590 # Don't include this header unless you use one of its functions.
591 sc_prohibit_ignore_value_without_use
:
592 @h
='ignore-value.h' re
='\<ignore_(value|ptr) *\(' \
593 $(_sc_header_without_use
)
595 # Don't include this header unless you use one of its functions.
596 sc_prohibit_error_without_use
:
598 re
='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
599 $(_sc_header_without_use
)
601 # Don't include xalloc.h unless you use one of its symbols.
602 # Consider these symbols:
603 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
604 # perl -lne 'm{^(?:_Noreturn )?(?:void|char) \*?(\w+) *\(} and print $1' lib/xalloc.h
605 # Divide into two sets on case, and filter each through this:
606 # | sort | perl -MRegexp::Assemble -le \
607 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
608 _xa1
= x
(i
(m
(emdup0?|alloc
)|realloc
(array
)?|
([cz
]|nm
)alloc
)|
([pz
]|c
(har
)?|
2n?re|nm
)alloc|realloc
(array
)?|m
(alloc|emdup
)|alloc_die|strdup
)
609 _xa2
= X
([CZ
]|N?M
)ALLOC
610 sc_prohibit_xalloc_without_use
:
612 re
='\<($(_xa1)|$(_xa2)) *\('\
613 $(_sc_header_without_use
)
615 # Extract function names:
616 # perl -lne '/^(?:extern )?(?:void|char|Hash_table) \*?(\w+) *\(/ and print $1' lib/hash.h
618 hash_
(re
(set_tuning|move
)|xin
(itialize|sert
)|in
(itialize|sert
)|get_
(firs|nex
)t|print_statistics|
(delet|fre
)e|lookup|clear
)
619 _hash_fn
= \
<($(_hash_re
)) *\
(
620 _hash_struct
= (struct
)?\
<[Hh
]ash_
(table|tuning
)\
>
621 sc_prohibit_hash_without_use
:
623 re
='$(_hash_fn)|$(_hash_struct)'\
624 $(_sc_header_without_use
)
626 sc_prohibit_cloexec_without_use
:
627 @h
='cloexec.h' re
='\<(set_cloexec_flag|dup_cloexec) *\(' \
628 $(_sc_header_without_use
)
630 sc_prohibit_posixver_without_use
:
631 @h
='posixver.h' re
='\<posix2_version *\(' $(_sc_header_without_use
)
633 sc_prohibit_same_without_use
:
634 @h
='same.h' re
='\<same_name(at)? *\(' $(_sc_header_without_use
)
636 sc_prohibit_hash_pjw_without_use
:
639 $(_sc_header_without_use
)
641 sc_prohibit_safe_read_without_use
:
642 @h
='safe-read.h' re
='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
643 $(_sc_header_without_use
)
645 sc_prohibit_argmatch_without_use
:
647 re
='(\<(ARGMATCH_DEFINE_GROUP|ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
648 $(_sc_header_without_use
)
650 sc_prohibit_canonicalize_without_use
:
651 @h
='canonicalize.h' \
652 re
='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode|file_name)' \
653 $(_sc_header_without_use
)
655 sc_prohibit_root_dev_ino_without_use
:
656 @h
='root-dev-ino.h' \
657 re
='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
658 $(_sc_header_without_use
)
660 sc_prohibit_openat_without_use
:
662 re
='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat|(FCHMOD|FCHOWN|STAT)AT_INLINE)\>' \
663 $(_sc_header_without_use
)
665 # Prohibit the inclusion of c-ctype.h without an actual use.
666 ctype_re
= isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
667 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
668 sc_prohibit_c_ctype_without_use
:
669 @h
='c-ctype.h' re
='\<c_($(ctype_re)) *\(' \
670 $(_sc_header_without_use
)
672 # The following list was generated by running:
673 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
674 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
676 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
677 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
678 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
679 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
680 _sig_function_re
= $(subst $(_sp
),|
,$(strip $(_sig_functions
)))
681 # The following were extracted from "man signal.h" manually.
682 _sig_types_and_consts
= \
683 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
684 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
685 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
686 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
687 sigstack sigval stack_t ucontext_t
688 # generated via this:
689 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
691 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
692 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
693 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
694 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
695 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
696 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
697 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
699 _sig_syms_re
= $(subst $(_sp
),|
,$(strip $(_sig_names
) $(_sig_types_and_consts
)))
701 # Prohibit the inclusion of signal.h without an actual use.
702 sc_prohibit_signal_without_use
:
704 re
='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
705 $(_sc_header_without_use
)
707 # Don't include stdio--.h unless you use one of its functions.
708 sc_prohibit_stdio--_without_use
:
709 @h
='stdio--.h' re
='\<((f(re)?|p)open|tmpfile) *\(' \
710 $(_sc_header_without_use
)
712 # Don't include stdio-safer.h unless you use one of its functions.
713 sc_prohibit_stdio-safer_without_use
:
714 @h
='stdio-safer.h' re
='\<((f(re)?|p)open|tmpfile)_safer *\(' \
715 $(_sc_header_without_use
)
717 # Prohibit the inclusion of strings.h without a sensible use.
718 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
719 sc_prohibit_strings_without_use
:
721 re
='\<(strn?casecmp|ffs(ll)?)\>' \
722 $(_sc_header_without_use
)
724 # Extract the raw list of symbol names with this:
725 gl_extract_define_simple
= \
726 /^\
# *define ([A-Z]\w+)\(/ and print $$1
727 # Filter out duplicates and convert to a space-separated list:
729 $(shell f
=$(gnulib_dir
)/lib
/intprops.h
; \
730 perl
-lne
'$(gl_extract_define_simple)' $$f |
sort -u | tr
'\n' ' ')
731 # Remove trailing space and convert to a regular expression:
732 _intprops_syms_re
= $(subst $(_sp
),|
,$(strip $(_intprops_names
)))
733 # Prohibit the inclusion of intprops.h without an actual use.
734 sc_prohibit_intprops_without_use
:
736 re
='\<($(_intprops_syms_re)) *\(' \
737 $(_sc_header_without_use
)
740 NULL|max_align_t|nullptr_t|offsetof|ptrdiff_t|size_t|unreachable|wchar_t
741 # Prohibit the inclusion of stddef.h without an actual use.
742 sc_prohibit_stddef_without_use
:
744 re
='\<($(_stddef_syms_re))\>' \
745 $(_sc_header_without_use
)
747 _de1
= dirfd|
(close|
(fd
)?open|read|rewind|seek|tell
)dir(64)?
(_r
)?
748 _de2
= (versionsort|struct dirent|getdirentries|alphasort|scandir
(at
)?
)(64)?
749 _de3
= MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
750 _dirent_syms_re
= $(_de1
)|
$(_de2
)|
$(_de3
)
751 # Prohibit the inclusion of dirent.h without an actual use.
752 sc_prohibit_dirent_without_use
:
754 re
='\<($(_dirent_syms_re))\>' \
755 $(_sc_header_without_use
)
757 # Prohibit the inclusion of verify.h without an actual use.
758 sc_prohibit_verify_without_use
:
760 re
='\<(verify(_expr)?|assume) *\(' \
761 $(_sc_header_without_use
)
763 # Don't include xfreopen.h unless you use one of its functions.
764 sc_prohibit_xfreopen_without_use
:
765 @h
='xfreopen.h' re
='\<xfreopen *\(' $(_sc_header_without_use
)
768 @prohibit
='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
769 halt
='do not use HAVE''_FCNTL_H or O'_NDELAY \
772 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
774 # Each nonempty ChangeLog line must start with a year number, or a TAB.
776 @prohibit
='^[^12 ]' \
777 in_vc_files
='^ChangeLog$$' \
778 halt
='found unexpected prefix in a ChangeLog' \
781 # Ensure that each .c file containing a "main" function also
782 # calls bindtextdomain.
784 @require
='bindtextdomain *\(' \
785 in_vc_files
='\.c$$' \
786 containing
='\<main *(' \
787 halt
='the above files do not call bindtextdomain' \
790 # Require that the final line of each test-lib.sh-using test be this one:
792 # Note: this test requires GNU grep's --label= option.
793 Exit_witness_file ?
= tests
/test-lib.sh
794 Exit_base
:= $(notdir $(Exit_witness_file
))
795 sc_require_test_exit_idiom
:
796 @if
test -f
$(srcdir)/$(Exit_witness_file
); then \
798 for i in
$$($(GREP
) -l
-F
'srcdir/$(Exit_base)' \
799 $$($(VC_LIST
) tests
)); do \
800 tail
-n1
$$i |
$(GREP
) '^Exit .' > /dev
/null \
801 && : ||
{ die
=1; echo
$$i; } \
804 { echo
1>&2 '$(ME): the final line in each of the above is not:'; \
805 echo
1>&2 'Exit something'; \
811 halt
='found trailing blank(s)' \
812 exclude
='^Binary file .* matches$$' \
815 # Match lines like the following, but where there is only one space
816 # between the options and the description:
817 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
818 longopt_re
= --[a-z
][0-9A-Za-z-
]*(\
[?
=[0-9A-Za-z-
]*]?
)?
819 sc_two_space_separator_in_usage
:
820 @prohibit
='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
821 halt
='help2man requires at least two spaces between an option and its description'\
824 # A regexp matching function names like "error" that may be used
825 # to emit translatable messages.
826 _gl_translatable_diag_func_re ?
= error
828 # Look for diagnostics that aren't marked for translation.
829 # This won't find any for which error's format string is on a separate line.
830 sc_unmarked_diagnostics
:
831 @prohibit
='\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
832 exclude
='(_|ngettext ?)\(' \
833 halt
='found unmarked diagnostic(s)' \
836 # Avoid useless parentheses like those in this example:
837 # #if defined (SYMBOL) || defined (SYM2)
838 sc_useless_cpp_parens
:
839 @prohibit
='^# *if .*defined *\(' \
840 halt
='found useless parentheses in cpp directive' \
843 # List headers for which HAVE_HEADER_H is always true, assuming you are
844 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
845 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
846 # requires the gnulib module that guarantees the usability of that header.
847 gl_assured_headers_
= \
848 cd
$(gnulib_dir
)/lib
&& echo
*.in.h|
$(SED
) 's/\.in\.h//g'
850 # Convert the list of names to upper case, and replace each space with "|".
851 az_
= abcdefghijklmnopqrstuvwxyz
852 AZ_
= ABCDEFGHIJKLMNOPQRSTUVWXYZ
853 gl_header_upper_case_or_
= \
854 $$($(gl_assured_headers_
) \
855 | tr
$(az_
)/.
- $(AZ_
)___ \
858 sc_prohibit_always_true_header_tests
:
859 @or
=$(gl_header_upper_case_or_
); \
860 re
="HAVE_($$or)_H"; \
861 prohibit
='\<'"$$re"'\>' \
862 halt
=$$(printf
'%s\n' \
863 'do not test the above HAVE_<header>_H symbol(s);' \
864 ' with the corresponding gnulib module, they are always true') \
867 sc_prohibit_defined_have_decl_tests
:
868 @prohibit
='(#[ ]*ifn?def|\<defined)\>[ (]+HAVE_DECL_' \
869 halt
='HAVE_DECL macros are always defined' \
872 # ==================================================================
873 gl_other_headers_ ?
= \
878 # Perl -lne code to extract "significant" cpp-defined symbols from a
879 # gnulib header file, eliminating a few common false-positives.
880 # The exempted names below are defined only conditionally in gnulib,
881 # and hence sometimes must/may be defined in application code.
882 gl_extract_significant_defines_
= \
883 /^\
# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
884 && $$2 !~
/(?
:rpl_|_used_without_
)/\
885 && $$1 !~
/^
(?
:NSIG|ENODATA
)$$/\
886 && $$1 !~
/^
(?
:SA_RESETHAND|SA_RESTART
)$$/\
889 # Create a list of regular expressions matching the names
890 # of macros that are guaranteed to be defined by parts of gnulib.
892 gen_h
=$(gl_generated_headers_
); \
893 (cd
$(gnulib_dir
)/lib
; \
894 for f in
*.in.h
$(gl_other_headers_
); do \
896 && perl
-lne
'$(gl_extract_significant_defines_)' $$f; \
899 |
$(SED
) 's/^/^ *# *(define|undef) */;s/$$/\\>/'
902 # Don't define macros that we already get from gnulib header files.
903 sc_prohibit_always-defined_macros
:
904 @if
test -d
$(gnulib_dir
); then \
905 case
$$(echo
all: |
$(GREP
) -l
-f
- Makefile
) in Makefile
);; *) \
906 echo
'$(ME): skipping $@: you lack GNU grep' 1>&2; exit
0;; \
908 regex
=$$($(def_sym_regex
)); export regex
; \
910 | xargs sh
-c
'echo $$regex | $(GREP) -E -f - "$$@"' \
912 && { printf
'$(ME): define the above' \
913 ' via some gnulib .h file\n' 1>&2; \
917 # ==================================================================
919 # Prohibit checked in backup files.
920 sc_prohibit_backup_files
:
921 @
$(VC_LIST
) |
$(GREP
) '~$$' && \
922 { echo
'$(ME): found version controlled backup file' 1>&2; \
925 # Require the latest GPL.
927 @prohibit
='either ''version [^3]' \
928 halt
='GPL vN, N!=3' \
931 # Require the latest GFDL. Two regexp, since some .texi files end up
932 # line wrapping between 'Free Documentation License,' and 'Version'.
933 _GFDL_regexp
= (Free
''Documentation.
*Version
1\.
[^
3]|Version
1\.
[^
3] or any
)
935 @prohibit
='$(_GFDL_regexp)' \
936 halt
='GFDL vN, N!=3' \
939 # Don't use Texinfo's @acronym{}.
940 # https://lists.gnu.org/r/bug-gnulib/2010-03/msg00321.html
941 texinfo_suffix_re_ ?
= \.
(txi|texi
(nfo
)?
)$$
943 @prohibit
='@acronym\{' \
944 in_vc_files
='$(texinfo_suffix_re_)' \
945 halt
='found use of Texinfo @acronym{}' \
949 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
951 sc_prohibit_cvs_keyword
:
952 @prohibit
='\$$($(cvs_keywords))\$$' \
953 halt
='do not use CVS keyword expansion' \
956 # This Perl code is slightly obfuscated. Not only is each "$" doubled
957 # because it's in a Makefile, but the $$c's are comments; we cannot
958 # use "#" due to the way the script ends up concatenated onto one line.
959 # It would be much more concise, and would produce better output (including
960 # counts) if written as:
961 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
962 # but that would be far less efficient, reading the entire contents
963 # of each file, rather than just the last two bytes of each.
964 # In addition, while the code below detects both blank lines and a missing
965 # newline at EOF, the above detects only the former.
967 # This is a perl script that is expected to be the single-quoted argument
968 # to a command-line "-le". The remaining arguments are file names.
969 # Print the name of each file that does not end in exactly one newline byte.
970 # I.e., warn if there are blank lines (2 or more newlines), or if the
971 # last byte is not a newline. However, currently we don't complain
972 # about any file that contains exactly one byte.
973 # Exit nonzero if at least one such file is found, otherwise, exit 0.
974 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
976 # Use this if you want to remove trailing empty lines from selected files:
977 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
979 require_exactly_one_NL_at_EOF_
= \
980 foreach my
$$f (@ARGV
) \
982 open F
, "<", $$f or
(warn
"failed to open $$f: $$!\n"), next
; \
983 my
$$p = sysseek
(F
, -2, 2); \
984 my
$$c = "seek failure probably means file has < 2 bytes; ignore"; \
985 my
$$last_two_bytes; \
986 defined
$$p and
$$p = sysread F
, $$last_two_bytes, 2; \
988 $$c = "ignore read failure"; \
989 $$p && ($$last_two_bytes eq
"\n\n" \
990 || substr
($$last_two_bytes,1) ne
"\n") \
991 and
(print $$f), $$fail=1; \
993 END
{ exit defined
$$fail }
994 sc_prohibit_empty_lines_at_EOF
:
996 | xargs perl
-le
'$(require_exactly_one_NL_at_EOF_)' \
997 ||
{ echo
'$(ME): empty line(s) or no newline at EOF' 1>&2; \
1001 # Make sure we don't use st_blocks. Use ST_NBLOCKS or STP_NBLOCKS instead.
1002 # This is a bit of a kludge, since it prevents use of the string
1003 # even in comments, but for now it does the job with no false positives.
1004 sc_prohibit_stat_st_blocks
:
1005 @prohibit
='[.>]st_blocks' \
1006 halt
='do not use st_blocks; use ST_NBLOCKS or STP_NBLOCKS' \
1007 $(_sc_search_regexp
)
1009 # Make sure we don't define any S_IS* macros in src/*.c files.
1010 # They're already defined via gnulib's sys/stat.h replacement.
1011 sc_prohibit_S_IS_definition
:
1012 @prohibit
='^ *# *define *S_IS' \
1013 halt
='do not define S_IS* macros; include <sys/stat.h>' \
1014 $(_sc_search_regexp
)
1016 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
1017 # that is shared by two definitions below.
1018 perl_filename_lineno_text_
= \
1020 -e
' $$n = ($$` =~ tr/\n/\n/ + 1);' \
1021 -e
' ($$v = $$&) =~ s/\n/\\n/g;' \
1022 -e
' print "$$ARGV:$$n:$$v\n";' \
1025 prohibit_doubled_words_
= \
1026 the then in an on if is it but for or at and do to can
1027 # expand the regex before running the check to avoid using expensive captures
1028 prohibit_doubled_word_expanded_
= \
1029 $(join $(prohibit_doubled_words_
),$(addprefix \s
+,$(prohibit_doubled_words_
)))
1030 prohibit_doubled_word_RE_ ?
= \
1031 /\b(?
:$(subst $(_sp
),|
,$(prohibit_doubled_word_expanded_
)))\b/gims
1032 prohibit_doubled_word_
= \
1033 -e
'while ($(prohibit_doubled_word_RE_))' \
1034 $(perl_filename_lineno_text_
)
1036 # Define this to a regular expression that matches
1037 # any filename:dd:match lines you want to ignore.
1038 # The default is to ignore no matches.
1039 ignore_doubled_word_match_RE_ ?
= ^
$$
1041 sc_prohibit_doubled_word
:
1042 @
$(VC_LIST_EXCEPT
) \
1043 | xargs perl
-n
-0777 $(prohibit_doubled_word_
) \
1044 |
$(GREP
) -vE
'$(ignore_doubled_word_match_RE_)' \
1046 && { echo
'$(ME): doubled words' 1>&2; exit
1; } \
1049 # A regular expression matching undesirable combinations of words like
1050 # "can not"; this matches them even when the two words appear on different
1051 # lines, but not when there is an intervening delimiter like "#" or "*".
1052 # Similarly undesirable, "See @xref{...}", since an @xref should start
1053 # a sentence. Explicitly prohibit any prefix of "see" or "also".
1054 # Also prohibit a prefix matching "\w+ +".
1055 # @pxref gets the same see/also treatment and should be parenthesized;
1056 # presume it must *not* start a sentence.
1057 # POSIX spells it "timestamp" rather than "time\s+stamp", so we do, too.
1058 bad_xref_re_ ?
= (?
:[\w
,:;] +|
(?
:see|also
)\s
+)\@xref\
{
1059 bad_pxref_re_ ?
= (?
:[.
!?
]|
(?
:see|also
))\s
+\@pxref\
{
1060 prohibit_undesirable_word_seq_RE_ ?
= \
1061 /(?
:\bcan\s
+not
\b|
\btime\s
+stamps?
\b|
$(bad_xref_re_
)|
$(bad_pxref_re_
))/gims
1062 prohibit_undesirable_word_seq_
= \
1063 -e
'while ($(prohibit_undesirable_word_seq_RE_))' \
1064 $(perl_filename_lineno_text_
)
1065 # Define this to a regular expression that matches
1066 # any filename:dd:match lines you want to ignore.
1067 # The default is to ignore no matches.
1068 ignore_undesirable_word_sequence_RE_ ?
= ^
$$
1070 sc_prohibit_undesirable_word_seq
:
1071 @
$(VC_LIST_EXCEPT
) \
1072 | xargs perl
-n
-0777 $(prohibit_undesirable_word_seq_
) \
1073 |
$(GREP
) -vE
'$(ignore_undesirable_word_sequence_RE_)' \
1075 && { echo
'$(ME): undesirable word sequence' >&2; exit
1; } \
1078 # Except for shell files and for loops, double semicolon is probably a mistake
1079 sc_prohibit_double_semicolon
:
1080 @prohibit
='; *;[ {} \]*(/[/*]|$$)' \
1081 in_vc_files
='\.[chly]$$' \
1082 exclude
='\bfor *\(.*\)' \
1083 halt
="Double semicolon detected" \
1084 $(_sc_search_regexp
)
1086 _ptm1
= use
"test C1 && test C2", not
"test C1 -''a C2"
1087 _ptm2
= use
"test C1 || test C2", not
"test C1 -''o C2"
1088 # Using test's -a and -o operators is not portable.
1089 # We prefer test over [, since the latter is spelled [[ in configure.ac.
1090 sc_prohibit_test_minus_ao
:
1091 @prohibit
='(\<test| \[+) .+ -[ao] ' \
1092 halt
='$(_ptm1); $(_ptm2)' \
1093 $(_sc_search_regexp
)
1095 # Avoid a test bashism.
1096 sc_prohibit_test_double_equal
:
1097 @prohibit
='(\<test| \[+) .+ == ' \
1098 containing
='#! */bin/[a-z]*sh' \
1099 halt
='use "test x = x", not "test x =''= x"' \
1100 $(_sc_search_regexp
)
1102 # Each program that uses proper_name_utf8 must link with one of the
1103 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
1104 # The perl -0777 invocation below extracts the possibly-multi-line
1105 # definition of LDADD from the appropriate Makefile.am and exits 0
1106 # when it contains "ICONV".
1107 sc_proper_name_utf8_requires_ICONV
:
1108 @progs
=$$($(VC_LIST_EXCEPT
) \
1109 | xargs
$(GREP
) -l
'proper_name_utf8 ''("'); \
1110 if
test "x$$progs" != x
; then \
1112 for p in
$$progs; do \
1113 dir=$$(dirname
"$$p"); \
1115 -ne
'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
1116 $$dir/Makefile.am
&& continue
; \
1117 base
=$$(basename "$$p" .c
); \
1118 $(GREP
) "$${base}_LDADD.*ICONV)" $$dir/Makefile.am
> /dev
/null \
1119 ||
{ fail
=1; echo
1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
1121 test $$fail = 1 && \
1122 { echo
1>&2 '$(ME): the above do not link with any ICONV library'; \
1126 # Warn about "c0nst struct Foo const foo[]",
1127 # but not about "char const *const foo" or "#define const const".
1129 @prohibit
='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
1130 halt
='redundant "const" in declarations' \
1131 $(_sc_search_regexp
)
1133 sc_const_long_option
:
1134 @prohibit
='^ *static.*struct option ' \
1135 exclude
='const struct option|struct option const' \
1136 halt
='add "const" to the above declarations' \
1137 $(_sc_search_regexp
)
1140 $$($(SED
) -n
'/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
1143 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
1147 # Ensure that we don't accidentally insert an entry into an old NEWS block.
1149 @if
test -f
$(srcdir)/NEWS
; then \
1150 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
1151 { echo
'$(ME): you have modified old NEWS' 1>&2; exit
1; }; \
1154 # Update the hash stored above. Do this after each release and
1155 # for any corrections to old entries.
1156 update-NEWS-hash
: NEWS
1157 perl
-pi
-e
's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1160 # Ensure that we use only the standard $(VAR) notation,
1161 # not @...@ in Makefile.am, now that we can rely on automake
1162 # to emit a definition for each substituted variable.
1163 # However, there is still one case in which @VAR@ use is not just
1164 # legitimate, but actually required: when augmenting an automake-defined
1165 # variable with a prefix. For example, gettext uses this:
1166 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1167 # otherwise, makeinfo would put German or French (current locale)
1168 # navigation hints in the otherwise-English documentation.
1170 # Allow the package to add exceptions via a hook in cfg.mk;
1171 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1172 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1173 _makefile_at_at_check_exceptions ?
=
1174 sc_makefile_at_at_check
:
1175 @perl
-ne
'/\@\w+\@/' \
1176 -e
' && !/(\w+)\s+=.*\@\1\@$$/' \
1177 -e
''$(_makefile_at_at_check_exceptions
) \
1178 -e
'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1179 $$($(VC_LIST_EXCEPT
) |
$(GREP
) -E
'(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1180 && { echo
'$(ME): use $$(...), not @...@' 1>&2; exit
1; } ||
:
1183 $(AM_V_GEN
)if
$(SED
) -n
$(news-check-lines-spec
)p
$< \
1184 |
$(GREP
) -E
$(news-check-regexp
) >/dev
/null
; then \
1187 echo
'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1191 sc_makefile_TAB_only_indentation
:
1192 @prohibit
='^ [ ]{8}' \
1193 in_vc_files
='akefile|\.mk$$' \
1194 halt
='found TAB-8-space indentation' \
1195 $(_sc_search_regexp
)
1198 @prohibit
='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1199 in_vc_files
='(^configure\.ac|\.m4)$$' \
1200 halt
='quote the first arg to AC_DEF*' \
1201 $(_sc_search_regexp
)
1203 fix_po_file_diag
= \
1204 'you have changed the set of files with translatable diagnostics;\n\
1205 apply the above patch\n'
1207 # Generate a list of files in which to search for translatable strings.
1208 perl_translatable_files_list_
= \
1209 -e
'foreach $$file (@ARGV) {' \
1210 -e
' \# Consider only file extensions with one or two letters' \
1211 -e
' $$file =~ /\...?$$/ or next;' \
1212 -e
' \# Ignore m4 and mk files' \
1213 -e
' $$file =~ /\.m[4k]$$/ and next;' \
1214 -e
' \# Ignore a .c or .h file with a corresponding .l or .y file' \
1215 -e
' $$file =~ /(.+)\.[ch]$$/ && (-e "$${1}.l" || -e "$${1}.y")' \
1217 -e
' \# Skip unreadable files' \
1218 -e
' -r $$file or next;' \
1219 -e
' print "$$file ";' \
1222 # Verify that all source files using _() (more specifically, files that
1223 # match $(_gl_translatable_string_re)) are listed in po/POTFILES.in.
1224 po_file ?
= $(srcdir)/po
/POTFILES.in
1225 generated_files ?
= $(srcdir)/lib
/*.
[ch
]
1226 _gl_translatable_string_re ?
= \b(N?_|gettext
*)\
([^
)"]*("|
$$)
1228 @if
test -f
$(po_file
); then \
1229 $(GREP
) -E
-v
'^(#|$$)' $(po_file
) \
1230 |
$(GREP
) -v
'^src/false\.c$$' |
sort > $@
-1; \
1231 { $(VC_LIST_EXCEPT
); echo
$(generated_files
); } \
1232 | xargs perl
$(perl_translatable_files_list_
) \
1233 | xargs
$(GREP
) -E
-l
'$(_gl_translatable_string_re)' \
1234 |
$(SED
) 's|^$(_dot_escaped_srcdir)/||' \
1236 diff
-u
-L
$(po_file
) -L
$(po_file
) $@
-1 $@
-2 \
1237 ||
{ printf
'$(ME): '$(fix_po_file_diag
) 1>&2; exit
1; }; \
1241 # Sometimes it is useful to change the PATH environment variable
1242 # in Makefiles. When doing so, it's better not to use the Unix-centric
1243 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1244 msg
= 'Do not use ":" above; use $$(PATH_SEPARATOR) instead'
1245 sc_makefile_path_separator_check
:
1246 @prohibit
='PATH[=].*:' \
1247 in_vc_files
='akefile|\.mk$$' \
1249 $(_sc_search_regexp
)
1251 sc_makefile_DISTCHECK_CONFIGURE_FLAGS
:
1252 @prohibit
='^DISTCHECK_CONFIGURE_FLAGS' \
1253 in_vc_files
='akefile|\.mk$$' \
1254 halt
="use AM_DISTCHECK_CONFIGURE_FLAGS" \
1255 $(_sc_search_regexp
)
1257 # Check that 'make alpha' will not fail at the end of the process,
1258 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1261 $(AM_V_GEN
)if
test -d
$(release_archive_dir
); then \
1262 for file in
$(DIST_ARCHIVES
); do \
1263 for p in .
/ $(release_archive_dir
)/; do \
1264 test -e
$$p$$file || continue
; \
1266 ||
{ echo ERROR
: $$p$$file is not writable
; fail
=1; }; \
1269 test "$$fail" && exit
1 ||
: ; \
1273 v_etc_file
= $(gnulib_dir
)/lib
/version-etc.c
1274 sample-test
= tests
/sample-test
1275 texi
= doc
/$(PACKAGE
).texi
1276 # Make sure that the copyright date in $(v_etc_file) is up to date.
1277 # Do the same for the $(sample-test) and the main doc/.texi file.
1279 @require
='enum { COPYRIGHT_YEAR = '$$(date
+%Y
)' };' \
1280 in_files
=$(v_etc_file
) \
1281 halt
='out of date copyright in $(v_etc_file); update it' \
1282 $(_sc_search_regexp
)
1283 @require
='# Copyright \(C\) '$$(date
+%Y
)' Free' \
1284 in_vc_files
=$(sample-test
) \
1285 halt
='out of date copyright in $(sample-test); update it' \
1286 $(_sc_search_regexp
)
1287 @require
='Copyright @copyright\{} .*'$$(date
+%Y
) \
1288 in_vc_files
=$(texi
) \
1289 halt
='out of date copyright in $(texi); update it' \
1290 $(_sc_search_regexp
)
1292 # If tests/help-version exists and seems to be new enough, assume that its
1293 # use of init.sh and path_prepend_ is correct, and ensure that every other
1294 # use of init.sh is identical.
1295 # This is useful because help-version cross-checks prog --version
1296 # with $(VERSION), which verifies that its path_prepend_ invocation
1297 # sets PATH correctly. This is an inexpensive way to ensure that
1298 # the other init.sh-using tests also get it right.
1299 _hv_file ?
= $(srcdir)/tests
/help-version
1300 _hv_regex_weak ?
= ^
*\. .
*/init\.sh
"
1301 # Fix syntax-highlighters "
1302 _hv_regex_strong ?
= ^
*\.
"\$${srcdir=\.}/init\.sh"
1303 sc_cross_check_PATH_usage_in_tests
:
1304 @if
test -f
$(_hv_file
); then \
1305 $(GREP
) -l
'VERSION mismatch' $(_hv_file
) >/dev
/null \
1306 ||
{ echo
"$@: skipped: no such file: $(_hv_file)" 1>&2; \
1308 $(GREP
) -lE
'$(_hv_regex_strong)' $(_hv_file
) >/dev
/null \
1309 ||
{ echo
"$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1311 good
=$$($(GREP
) -E
'$(_hv_regex_strong)' $(_hv_file
)); \
1313 | xargs
$(GREP
) -lE
'$(_hv_regex_weak)' \
1314 | xargs
$(GREP
) -LFx
"$$good" \
1316 && { printf
"$(ME): the above files use" \
1317 " path_prepend_ inconsistently\n" 1>&2; \
1322 # BRE regex of file contents to identify a test script.
1323 _test_script_regex ?
= \
<init\.sh\
>
1325 # In tests, use "compare expected actual", not the reverse.
1326 sc_prohibit_reversed_compare_failure
:
1327 @prohibit
='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1328 containing
='$(_test_script_regex)' \
1329 halt
='reversed compare arguments' \
1330 $(_sc_search_regexp
)
1332 # #if HAVE_... will evaluate to false for any non numeric string.
1333 # That would be flagged by using -Wundef, however gnulib currently
1334 # tests many undefined macros, and so we can't enable that option.
1335 # So at least preclude common boolean strings as macro values.
1337 @prohibit
='^#define.*(yes|no|true|false)$$' \
1338 in_files
='$(CONFIG_INCLUDE)' \
1339 halt
='Use 0 or 1 for macro values' \
1340 $(_sc_search_regexp
)
1342 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1343 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1344 # a limit, not an array or alloca size.
1345 sc_prohibit_path_max_allocation
:
1346 @prohibit
='(\balloca *\([^)]*|\[[^]]*)\bPATH_MAX' \
1347 halt
='Avoid stack allocations of size PATH_MAX' \
1348 $(_sc_search_regexp
)
1350 sc_vulnerable_makefile_CVE-2009-4029
:
1351 @prohibit
='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1352 in_files
='(^|/)Makefile\.in$$' \
1353 halt
=$$(printf
'%s\n' \
1354 'the above files are vulnerable; beware of running' \
1355 ' "make dist*" rules, and upgrade to fixed automake' \
1356 ' see https://bugzilla.redhat.com/show_bug.cgi?id=542609 for details') \
1357 $(_sc_search_regexp
)
1359 sc_vulnerable_makefile_CVE-2012-3386
:
1360 @prohibit
='chmod a\+w \$$\(distdir\)' \
1361 in_files
='(^|/)Makefile\.in$$' \
1362 halt
=$$(printf
'%s\n' \
1363 'the above files are vulnerable; beware of running' \
1364 ' "make distcheck", and upgrade to fixed automake' \
1365 ' see https://bugzilla.redhat.com/show_bug.cgi?id=CVE-2012-3386 for details') \
1366 $(_sc_search_regexp
)
1368 sc_unportable_grep_q
:
1369 @prohibit
='grep -q' halt
="unportable 'grep -q', use >/dev/null instead" \
1370 $(_sc_search_regexp
)
1372 # The GNU Coding standards say that README should refer to both
1373 # INSTALL and the file that contains the copying conditions. This
1374 # shall be COPYING for GPL and COPYING.LESSER for LGPL.
1376 sc_readme_link_install
:
1377 @require
='INSTALL' \
1378 in_vc_files
='^README$$' \
1379 halt
='The README file should refer to INSTALL' \
1380 $(_sc_search_regexp
)
1382 sc_readme_link_copying
:
1383 @require
='COPYING' \
1384 in_vc_files
='^README$$' \
1385 halt
='The README file should refer to COPYING[.LESSER]' \
1386 $(_sc_search_regexp
)
1389 $(AM_V_GEN
)(unset CDPATH
; cd
$(srcdir) && $(VC
) diff
) > vc-diffs ||
:
1390 $(AM_V_at
)if
test -s vc-diffs
; then \
1392 echo
"Some files are locally modified:" 1>&2; \
1398 rel-files
= $(DIST_ARCHIVES
)
1400 gnulib-version
= $$(cd
$(gnulib_dir
) \
1401 && { git describe || git rev-parse
--short
=10 HEAD
; } )
1402 bootstrap-tools ?
= autoconf
,automake
,gnulib
1404 gpgv
= $$(gpgv2
--version
>/dev
/null
&& echo gpgv2 || echo gpgv
)
1405 # If it's not already specified, derive the GPG key ID from
1406 # the signed tag we've just applied to mark this release.
1409 && git cat-file tag v
$(VERSION
) \
1410 |
$(gpgv
) --status-fd
1 --keyring
/dev
/null
- - 2>/dev
/null \
1411 |
$(AWK
) '/^\[GNUPG:] ERRSIG / {print $$3; exit}')
1413 $$(gpg
--list-key
--with-colons
$(gpg_key_ID
) 2>/dev
/null \
1414 |
$(AWK
) -F
: '/^uid/ {print $$10; exit}' \
1415 |
$(SED
) -n
's/.*<\(.*\)>/\1/p')
1416 gpg_keyring_url ?
= https
://savannah.gnu.org
/project
/release-gpgkeys.php?group
=$(PACKAGE
)&download
=1
1418 translation_project_ ?
= coordinator@translationproject.org
1420 # Make info-gnu the default only for a stable release.
1421 announcement_Cc_stable
= $(translation_project_
), $(PACKAGE_BUGREPORT
)
1422 announcement_mail_headers_stable
= \
1423 To
: info-gnu@gnu.org \
1424 Cc
: $(announcement_Cc_
) \
1425 Mail-Followup-To
: $(PACKAGE_BUGREPORT
)
1427 announcement_Cc_alpha
= $(translation_project_
)
1428 announcement_mail_headers_alpha
= \
1429 To
: $(PACKAGE_BUGREPORT
) \
1430 Cc
: $(announcement_Cc_
)
1432 announcement_mail_Cc_beta
= $(announcement_mail_Cc_alpha
)
1433 announcement_mail_headers_beta
= $(announcement_mail_headers_alpha
)
1435 announcement_Cc_ ?
= $(announcement_Cc_
$(release-type
))
1436 announcement_mail_headers_ ?
= $(announcement_mail_headers_
$(release-type
))
1437 announcement
: NEWS ChangeLog
$(rel-files
)
1438 # Not $(AM_V_GEN) since the output of this command serves as
1439 # announcement message: it would start with " GEN announcement".
1440 $(AM_V_at
)$(srcdir)/$(_build-aux
)/announce-gen \
1441 --mail-headers
='$(announcement_mail_headers_)' \
1442 --release-type
=$(release-type
) \
1443 --package
=$(PACKAGE
) \
1444 --prev
=$(PREV_VERSION
) \
1446 --gpg-key-id
=$(gpg_key_ID
) \
1447 $$(test -n
"$(gpg_key_email)" && \
1448 echo
--gpg-key-email
="$(gpg_key_email)") \
1449 $$(test -n
"$(gpg_keyring_url)" && \
1450 echo
--gpg-keyring-url
="$(gpg_keyring_url)") \
1451 --srcdir=$(srcdir) \
1452 --news
=$(srcdir)/NEWS \
1453 --bootstrap-tools
=$(bootstrap-tools
) \
1454 $$(case
,$(bootstrap-tools
), in
(*,gnulib
,*) \
1455 echo
--gnulib-version
=$(gnulib-version
);; esac
) \
1456 $(addprefix --url-dir
=, $(url_dir_list
))
1458 .PHONY
: release-commit
1460 $(AM_V_GEN
)cd
$(srcdir) \
1461 && $(_build-aux
)/do-release-commit-and-tag \
1462 -C
$(abs_builddir
) $(RELEASE
)
1464 ## ---------------- ##
1465 ## Updating files. ##
1466 ## ---------------- ##
1468 ftp-gnu
= https
://ftp.gnu.org
/gnu
1469 www-gnu
= https
://www.gnu.org
1471 upload_dest_dir_ ?
= $(PACKAGE
)
1473 $(srcdir)/$(_build-aux
)/gnupload
$(GNUPLOADFLAGS
) \
1474 --to
$(gnu_rel_host
):$(upload_dest_dir_
) \
1476 emit_upload_commands
:
1477 @echo
=====================================
1478 @echo
=====================================
1479 @echo
'$(upload_command)'
1480 @echo
'# send the ~/announce-$(my_distdir) e-mail'
1481 @echo
=====================================
1482 @echo
=====================================
1486 $(AM_V_GEN
)$(upload_command
)
1488 define emit-commit-log
1489 printf
'%s\n' 'maint: post-release administrivia' '' \
1490 '* NEWS: Add header line for next release.' \
1491 '* .prev-version: Record previous version.' \
1492 '* cfg.mk (old_NEWS_hash): Auto-update.'
1495 .PHONY
: no-submodule-changes
1496 no-submodule-changes
:
1497 $(AM_V_GEN
)if
test -d
$(srcdir)/.git \
1498 && git
--version
>/dev
/null
2>&1; then \
1499 diff
=$$(cd
$(srcdir) && git submodule
-q
foreach \
1500 git diff-index
--name-only HEAD
) \
1502 case
$$diff in
'') ;; \
1503 *) echo
'$(ME): submodule files are locally modified:'; \
1504 echo
"$$diff"; exit
1;; esac
; \
1509 submodule-checks ?
= no-submodule-changes public-submodule-commit
1511 # Ensure that each sub-module commit we're using is public.
1512 # Without this, it is too easy to tag and release code that
1513 # cannot be built from a fresh clone.
1514 .PHONY
: public-submodule-commit
1515 public-submodule-commit
:
1516 $(AM_V_GEN
)if
test -d
$(srcdir)/.git \
1517 && git
--version
>/dev
/null
2>&1; then \
1519 git submodule
--quiet
foreach \
1520 'test "$$(git rev-parse "$$sha1")" \
1521 = "$$(git merge-base origin "$$sha1")"' \
1522 ||
{ echo
'$(ME): found non-public submodule commit' >&2; \
1527 # This rule has a high enough utility/cost ratio that it should be a
1528 # dependent of "check" by default. However, some of us do occasionally
1529 # commit a temporary change that deliberately points to a non-public
1530 # submodule commit, and want to be able to use rules like "make check".
1531 # In that case, run e.g., "make check gl_public_submodule_commit="
1532 # to disable this test.
1533 gl_public_submodule_commit ?
= public-submodule-commit
1534 check: $(gl_public_submodule_commit
)
1536 .PHONY
: alpha beta stable release
1537 ALL_RECURSIVE_TARGETS
+= alpha beta stable
1538 alpha beta stable
: $(local-check
) writable-files
$(submodule-checks
)
1539 $(AM_V_GEN
)test $@
= stable \
1540 && { echo
$(VERSION
) |
$(GREP
) -E
'^[0-9]+(\.[0-9]+)+$$' \
1541 ||
{ echo
"invalid version string: $(VERSION)" 1>&2; exit
1;};}\
1543 $(AM_V_at
)$(MAKE
) vc-diff-check
1544 $(AM_V_at
)$(MAKE
) news-check
1545 $(AM_V_at
)$(MAKE
) distcheck
1546 $(AM_V_at
)$(MAKE
) dist
1547 $(AM_V_at
)$(MAKE
) $(release-prep-hook
) RELEASE_TYPE
=$@
1548 $(AM_V_at
)$(MAKE
) -s emit_upload_commands RELEASE_TYPE
=$@
1551 $(AM_V_GEN
)$(MAKE
) _version
1552 $(AM_V_at
)$(MAKE
) $(release-type
)
1554 # Override this in cfg.mk if you follow different procedures.
1555 release-prep-hook ?
= release-prep
1557 gl_noteworthy_news_
= * Noteworthy changes in release ?.?
(????
-??
-??
) [?
]
1558 .PHONY
: release-prep
1560 $(AM_V_GEN
)$(MAKE
) --no-print-directory
-s announcement \
1561 > ~
/announce-
$(my_distdir
)
1562 $(AM_V_at
)if
test -d
$(release_archive_dir
); then \
1563 ln
$(rel-files
) $(release_archive_dir
); \
1564 chmod a-w
$(rel-files
); \
1566 $(AM_V_at
)echo
$(VERSION
) > $(prev_version_file
)
1567 $(AM_V_at
)$(MAKE
) update-NEWS-hash
1568 $(AM_V_at
)perl
-pi \
1569 -e
'$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' \
1571 $(AM_V_at
)msg
=$$($(emit-commit-log
)) || exit
1; \
1572 cd
$(srcdir) && $(VC
) commit
-m
"$$msg" -a
1574 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1575 # if the default $(PACKAGE)-derived name doesn't apply.
1580 $(AM_V_GEN
)test -z
"$(manual_title)" \
1581 && { echo
define manual_title in cfg.mk
1>&2; exit
1; } ||
:
1582 $(AM_V_at
)cd
'$(srcdir)/doc'; \
1583 $(SHELL
) ..
/$(_build-aux
)/gendocs.sh
$(gendocs_options_
) \
1584 -o
'$(abs_builddir)/doc/manual' \
1585 --email
$(PACKAGE_BUGREPORT
) $(PACKAGE
) \
1586 "$(PACKAGE_NAME) - $(manual_title)"
1587 $(AM_V_at
)echo
" *** Upload the doc/manual directory to web-cvs."
1589 .PHONY
: web-manual-update
1591 $(AM_V_GEN
)cd
$(srcdir) \
1592 && $(_build-aux
)/gnu-web-doc-update
-C
$(abs_builddir
)
1598 $(MAKE
) $(AM_MAKEFLAGS
) clean
1599 lcov
--directory .
--zerocounters
1601 COVERAGE_CCOPTS ?
= "-g --coverage"
1602 COVERAGE_OUT ?
= doc
/coverage
1605 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
)
1606 $(MAKE
) $(AM_MAKEFLAGS
) CFLAGS
=$(COVERAGE_CCOPTS
) CXXFLAGS
=$(COVERAGE_CCOPTS
) check
1607 mkdir
-p
$(COVERAGE_OUT
)
1608 lcov
--directory .
--output-file
$(COVERAGE_OUT
)/$(PACKAGE
).
info \
1612 genhtml
--output-directory
$(COVERAGE_OUT
) \
1613 $(COVERAGE_OUT
)/$(PACKAGE
).
info \
1614 --highlight
--frames
--legend \
1615 --title
"$(PACKAGE_NAME)"
1618 $(MAKE
) init-coverage
1619 $(MAKE
) build-coverage
1620 $(MAKE
) gen-coverage
1622 # Some projects carry local adjustments for gnulib modules via patches in
1623 # a gnulib patch directory whose default name is gl/ (defined in bootstrap
1624 # via local_gl_dir=gl). Those patches become stale as the originals evolve
1625 # in gnulib. Use this rule to refresh any stale patches. It applies each
1626 # patch to the original in $(gnulib_dir) and uses the temporary result to
1627 # generate a fuzz-free .diff file. If you customize the name of your local
1628 # gnulib patch directory via bootstrap.conf, this rule detects that name.
1629 # Run this from a non-VPATH (i.e., srcdir) build directory.
1630 .PHONY
: refresh-gnulib-patches
1631 refresh-gnulib-patches
:
1633 if
test -f bootstrap.conf
; then \
1634 t
=$$(perl
-lne
'/^\s*local_gl_dir=(\S+)/ and $$d=$$1;' \
1635 -e
'END{defined $$d and print $$d}' bootstrap.conf
); \
1636 test -n
"$$t" && gl
=$$t; \
1638 for diff in
$$(cd
$$gl; git ls-files |
$(GREP
) '\.diff$$'); do \
1639 b
=$$(printf
%s
"$$diff"|
$(SED
) 's/\.diff$$//'); \
1640 VERSION_CONTROL
=none \
1641 patch
"$(gnulib_dir)/$$b" "$$gl/$$diff" || exit
1; \
1642 ( cd
$(gnulib_dir
) || exit
1; \
1643 git diff
"$$b" > "../$$gl/$$diff"; \
1644 git checkout
$$b ) || exit
1; \
1647 # Update gettext files.
1648 PACKAGE ?
= $(shell basename $(PWD
))
1649 PO_DOMAIN ?
= $(PACKAGE
)
1650 POURL
= https
://translationproject.org
/latest
/$(PO_DOMAIN
)/
1653 rm -f
$(PODIR
)/*.po
&& \
1654 echo
"$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1655 wget
--no-verbose
--directory-prefix
$(PODIR
) --no-directories
--recursive
--level
1 --accept .po
--accept .po
.1 $(POURL
) && \
1656 echo
'en@boldquot' > $(PODIR
)/LINGUAS
&& \
1657 echo
'en@quot' >> $(PODIR
)/LINGUAS
&& \
1658 ls
$(PODIR
)/*.po |
$(SED
) 's/\.po//;s,$(PODIR)/,,' | \
1659 sort >> $(PODIR
)/LINGUAS
1663 indent_args ?
= -ppi
1
1664 C_SOURCES ?
= $$($(VC_LIST_EXCEPT
) | grep
'\.[ch]\(.in\)\?$$')
1665 INDENT_SOURCES ?
= $(C_SOURCES
)
1666 exclude_file_name_regexp--indent ?
= $(exclude_file_name_regexp--sc_indent
)
1669 indent
: # Running indent once is not idempotent, but running it twice is.
1670 $(AM_V_GEN
)indent
$(indent_args
) $(INDENT_SOURCES
) && \
1671 indent
$(indent_args
) $(INDENT_SOURCES
)
1674 @if
! indent
--version
2> /dev
/null | grep
'GNU indent' > /dev
/null
; then \
1675 echo
1>&2 '$(ME): sc_indent: GNU indent is missing'; \
1677 fail
=0; files
="$(INDENT_SOURCES)"; \
1678 for f in
$$files; do \
1679 indent
$(indent_args
) -st
$$f \
1680 | indent
$(indent_args
) -st
- \
1681 | diff
-u
$$f - || fail
=1; \
1683 test $$fail = 1 && \
1684 { echo
1>&2 '$(ME): code format error, try "make indent"'; \
1688 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1689 # put the assignments in this variable.
1690 update-copyright-env ?
=
1692 # Run this rule once per year (usually early in January)
1693 # to update all FSF copyright year lists in your project.
1694 # If you have an additional project-specific rule,
1695 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1696 # By default, exclude all variants of COPYING; you can also
1697 # add exemptions (such as ChangeLog..* for rotated change logs)
1698 # in the file .x-update-copyright.
1699 .PHONY
: update-copyright
1701 $(AM_V_GEN
)$(GREP
) -l
-w Copyright \
1702 $$(export VC_LIST_EXCEPT_DEFAULT
=COPYING
&& $(VC_LIST_EXCEPT
)) \
1703 |
$(update-copyright-env
) xargs
$(srcdir)/$(_build-aux
)/$@
1705 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1706 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1708 # NOTE: to override any _gl_TS_* default value, you must
1709 # define the variable(s) using "export" in cfg.mk.
1712 ALL_RECURSIVE_TARGETS
+= sc_tight_scope
1713 sc_tight_scope
: tight-scope.mk
1715 if
! $(GREP
) '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1717 && ! $(GREP
) -w noinst_HEADERS
$(srcdir)/$(_gl_TS_dir
)/Makefile.am \
1718 > /dev
/null
2>&1; then \
1719 echo
'$(ME): skipping $@'; \
1721 $(MAKE
) -s
-C
$(_gl_TS_dir
) \
1723 -f
$(abs_top_srcdir
)/cfg.mk \
1724 -f
$(abs_top_builddir
)/$< \
1731 tight-scope.mk
: $(ME
)
1732 @perl
-ne
'/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME
) > $@
-t
1738 # Most functions should have static scope.
1739 # Any that don't must be marked with 'extern', but 'main'
1740 # and 'usage' are exceptions: they're always extern, but
1741 # do not need to be marked. Symbols matching '__.*' are
1742 # reserved by the compiler, so are automatically excluded below.
1743 _gl_TS_unmarked_extern_functions ?
= main usage
1744 _gl_TS_function_match ?
= /^
(?
:$(_gl_TS_extern
)) +.
*?
(\w
+) *\
(/
1746 # If your project uses a macro like "XTERN", then put
1747 # the following in cfg.mk to override this default:
1748 # export _gl_TS_extern = extern|XTERN
1749 _gl_TS_extern ?
= extern
1751 # The second nm|grep checks for file-scope variables with 'extern' scope.
1752 # Without gnulib's progname module, you might put program_name here.
1753 # Symbols matching '__.*' are reserved by the compiler,
1754 # so are automatically excluded below.
1755 _gl_TS_unmarked_extern_vars ?
=
1757 # NOTE: the _match variables are perl expressions -- not mere regular
1758 # expressions -- so that you can extend them to match other patterns
1759 # and easily extract matched variable names.
1760 # For example, if your project declares some global variables via
1761 # a macro like this: GLOBAL(type, var_name, initializer), then you
1762 # can override this definition to automatically extract those names:
1763 # export _gl_TS_var_match = \
1764 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1765 _gl_TS_var_match ?
= /^
(?
:$(_gl_TS_extern
)) .
*?
(\w
+)(\
[.
*?
])?
;/
1767 # The names of object files in (or relative to) $(_gl_TS_dir).
1768 _gl_TS_obj_files ?
= *.
$(OBJEXT
)
1770 # Files in which to search for the one-line style extern declarations.
1771 # $(_gl_TS_dir)-relative.
1772 _gl_TS_headers ?
= $(noinst_HEADERS
)
1773 _gl_TS_other_headers ?
= *.h
1775 .PHONY
: _gl_tight_scope
1776 _gl_tight_scope
: $(bin_PROGRAMS
)
1777 sed_wrap
='s/^/^_?/;s/$$/$$/'; \
1778 t
=exceptions-
$$$$; \
1779 trap
's=$$?; rm -f $$t; exit $$s' 0; \
1780 for sig in
1 2 3 13 15; do \
1781 eval
"trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1783 src
=`for f in $(SOURCES); do \
1784 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1785 hdr
=`for f in $(_gl_TS_headers); do \
1786 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1787 ( printf
'%s\n' '__.*' $(_gl_TS_unmarked_extern_functions
); \
1788 $(GREP
) -h
-A1
'^extern .*[^;]$$' $$src \
1789 |
$(GREP
) -vE
'^(extern |--|#)' |
$(SED
) 's/ .*//; /^$$/d'; \
1791 '$(_gl_TS_function_match) and print $$1' $$hdr; \
1792 ) |
sort -u |
$(SED
) "$$sed_wrap" > $$t; \
1793 nm
-g
$(_gl_TS_obj_files
)|
$(SED
) -n
's/.* T //p'|
$(GREP
) -Ev
-f
$$t \
1794 && { echo the above functions should have static scope
>&2; \
1796 ( printf
'%s\n' '__.*' main
$(_gl_TS_unmarked_extern_vars
); \
1797 perl
-lne
'$(_gl_TS_var_match) and print $$1' \
1798 $$hdr $(_gl_TS_other_headers
) \
1799 ) |
sort -u |
$(SED
) "$$sed_wrap" > $$t; \
1800 nm
-g
$(_gl_TS_obj_files
) |
$(SED
) -n
's/.* [BCDGRS] //p' \
1801 |
sort -u |
$(GREP
) -Ev
-f
$$t \
1802 && { echo the above variables should have static scope
>&2; \